﻿// -*- C++ -*-
/*!
 * @file  Spider2020DataSubscribe.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "Spider2020DataSubscribe.h"

// Module specification
// <rtc-template block="module_spec">
static const char* spider2020datasubscribe_spec[] =
  {
    "implementation_id", "Spider2020DataSubscribe",
    "type_name",         "Spider2020DataSubscribe",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "Fukushima Computer System",
    "category",          "Simulator",
    "activity_type",     "EVENTDRIVEN",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
Spider2020DataSubscribe::Spider2020DataSubscribe(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : BodyIoRTC(manager),
    m_InSpider2020DataIn("InSpider2020Data", m_InSpider2020Data)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
Spider2020DataSubscribe::~Spider2020DataSubscribe()
{
}



RTC::ReturnCode_t Spider2020DataSubscribe::onInitialize(Body* body)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("InSpider2020Data", m_InSpider2020DataIn);

  // Set OutPort buffer

  // Set service provider to Ports

  // Set service consumers to Ports

  // Set CORBA Service Ports

  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t Spider2020DataSubscribe::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Spider2020DataSubscribe::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Spider2020DataSubscribe::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribe::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

bool Spider2020DataSubscribe::initializeSimulation(ControllerIO* io)
{
    int i = 0;
    
    if(io != nullptr){
       Body* body = io->body();
       if(body != nullptr){
           m_cnoid_Link[LINK_CHASSIS]    = body->link("CHASSIS");
           m_cnoid_Link[LINK_FR_FLIPPER] = body->link("FR_FLIPPER");
           m_cnoid_Link[LINK_FL_FLIPPER] = body->link("FL_FLIPPER");
           m_cnoid_Link[LINK_BR_FLIPPER] = body->link("BR_FLIPPER");
           m_cnoid_Link[LINK_BL_FLIPPER] = body->link("BL_FLIPPER");
           m_cnoid_Link[LINK_SHOULDER]   = body->link("SHOULDER");
           m_cnoid_Link[LINK_ARM]        = body->link("ARM");
           m_cnoid_Link[LINK_FOREARM]    = body->link("FOREARM");
           m_cnoid_Link[LINK_WRIST1]     = body->link("WRIST1");
           m_cnoid_Link[LINK_WRIST2]     = body->link("WRIST2");
           m_cnoid_Link[LINK_HAND]       = body->link("HAND");
           m_cnoid_Link[LINK_FINGER1]    = body->link("FINGER1");           
           m_cnoid_Link[LINK_FINGER2]    = body->link("FINGER2");
           m_cnoid_Link[LINK_FINGER3]    = body->link("FINGER3");
           for(i = 0; i < LINK_NUM; i++){
               if(m_cnoid_Link[i] == NULL){
                   return false;
               }
           }
           
 /*          m_cnoid_Link[LINK_SHOULDER]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_ARM]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_FOREARM]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_WRIST1]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_WRIST2]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_HAND]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_FINGER1]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_FINGER2]->setActuationMode(Link::JOINT_ANGLE);
           m_cnoid_Link[LINK_FINGER3]->setActuationMode(Link::JOINT_ANGLE);*/
       }
    }
    return true;
}

void Spider2020DataSubscribe::inputFromSimulator() {
//	printf("SHOULDER:%f\n", m_cnoid_Link[LINK_SHOULDER]->q());
//	printf("ARM     :%f\n", m_cnoid_Link[LINK_ARM]->q());
//	printf("FOREARM :%f\n", m_cnoid_Link[LINK_FOREARM]->q());
//	printf("WRIST1  :%f\n", m_cnoid_Link[LINK_WRIST1]->q());
//	printf("WRIST2  :%f\n", m_cnoid_Link[LINK_WRIST2]->q());
//	printf("HAND    :%f\n", m_cnoid_Link[LINK_HAND]->q());
 }

void Spider2020DataSubscribe::outputToSimulator() {
    if(m_InSpider2020DataIn.isNew()){
        m_InSpider2020DataIn.read();
        if(m_cnoid_Link[LINK_CHASSIS] != nullptr){
            double orir, orip, oriy;
            SE3 position;
            Vector3& p = position.translation();
            p.x() = m_InSpider2020Data.pose3d.data.position.x;
            p.y() = m_InSpider2020Data.pose3d.data.position.y;
            p.z() = m_InSpider2020Data.pose3d.data.position.z;
            orir = m_InSpider2020Data.pose3d.data.orientation.r;
            orip = m_InSpider2020Data.pose3d.data.orientation.p;
            oriy = m_InSpider2020Data.pose3d.data.orientation.y;
            Quaternion& q = position.rotation();
            double q0, q1, q2, q3;
            EulerAnglesToQuaternion(orir, orip, oriy, q0, q1, q2, q3);
            q.w() = q0;
            q.x() = q1;
            q.y() = q2;
            q.z() = q3;
        
            m_cnoid_Link[LINK_CHASSIS]->p() = position.translation();
            m_cnoid_Link[LINK_CHASSIS]->R() = position.rotation().toRotationMatrix();
        }
        
        // flipperAngle
        if(m_InSpider2020Data.flipperAngle.data.length() >= 4) {
            if(m_cnoid_Link[LINK_FR_FLIPPER] != nullptr){
//                m_cnoid_Link[LINK_FR_FLIPPER]->q() = m_InSpider2020Data.flipperAngle.data[0] + 1.047;
                m_cnoid_Link[LINK_FR_FLIPPER]->q() = m_InSpider2020Data.flipperAngle.data[0];
            }
            if(m_cnoid_Link[LINK_FL_FLIPPER] != nullptr){
//                m_cnoid_Link[LINK_FL_FLIPPER]->q() = 6.28 - m_InSpider2020Data.flipperAngle.data[1] + 1.047;
                m_cnoid_Link[LINK_FL_FLIPPER]->q() = m_InSpider2020Data.flipperAngle.data[1];
            }
            if(m_cnoid_Link[LINK_BR_FLIPPER] != nullptr){
//                m_cnoid_Link[LINK_BR_FLIPPER]->q() = 3.1415 - m_InSpider2020Data.flipperAngle.data[2] - 0.2216568;
                m_cnoid_Link[LINK_BR_FLIPPER]->q() = m_InSpider2020Data.flipperAngle.data[2];
            }
            if(m_cnoid_Link[LINK_BL_FLIPPER] != nullptr){
                m_cnoid_Link[LINK_BL_FLIPPER]->q() = m_InSpider2020Data.flipperAngle.data[3];
            }
        }
    
        // arm1Angular;
        if(m_InSpider2020Data.arm1Angular.data.length() >= 6) {
            if(m_cnoid_Link[LINK_SHOULDER] != nullptr){
                m_cnoid_Link[LINK_SHOULDER]->q() = m_InSpider2020Data.arm1Angular.data[0];
            }
            if(m_cnoid_Link[LINK_ARM] != nullptr){
                m_cnoid_Link[LINK_ARM]->q() = m_InSpider2020Data.arm1Angular.data[1];
            }
            if(m_cnoid_Link[LINK_FOREARM] != nullptr){
                m_cnoid_Link[LINK_FOREARM]->q() = m_InSpider2020Data.arm1Angular.data[2];
            }
            if(m_cnoid_Link[LINK_WRIST1] != nullptr){
                m_cnoid_Link[LINK_WRIST1]->q() = m_InSpider2020Data.arm1Angular.data[3];
            }
            if(m_cnoid_Link[LINK_WRIST2] != nullptr){
                m_cnoid_Link[LINK_WRIST2]->q() = m_InSpider2020Data.arm1Angular.data[4];
            }
            if(m_cnoid_Link[LINK_HAND] != nullptr){
                m_cnoid_Link[LINK_HAND]->q() = m_InSpider2020Data.arm1Angular.data[5];
            }
        }
    
        // arm1Finger
        if(m_InSpider2020Data.arm1Finger.data.length() >= 3) {
            double data;
            if(m_cnoid_Link[LINK_FINGER1] != nullptr){
                data = m_InSpider2020Data.arm1Finger.data[0];
                data = data / 6800 * 115 * 3.14 / 180;
                m_cnoid_Link[LINK_FINGER1]->q() = data;
            }
            if(m_cnoid_Link[LINK_FINGER2] != nullptr){
                data = m_InSpider2020Data.arm1Finger.data[1];
                data = data / 6800 * 115 * 3.14 / 180;
                m_cnoid_Link[LINK_FINGER2]->q() = data;
            }
            if(m_cnoid_Link[LINK_FINGER3] != nullptr){
                data = m_InSpider2020Data.arm1Finger.data[2];
                data = data / 6800 * 115 * 3.14 / 180;
                m_cnoid_Link[LINK_FINGER3]->q() = data;
            }
        }

    }
}

void Spider2020DataSubscribe::stopSimulation() {
}

void Spider2020DataSubscribe::EulerAnglesToQuaternion(double roll, double pitch, double yaw, double& q0, double& q1, double& q2, double& q3)
{
    double cosRoll = cos(roll / 2.0);
    double sinRoll = sin(roll / 2.0);
    double cosPitch = cos(pitch / 2.0);
    double sinPitch = sin(pitch / 2.0);
    double cosYaw = cos(yaw / 2.0);
    double sinYaw = sin(yaw / 2.0);
    
    q0 = cosRoll * cosPitch * cosYaw + sinRoll * sinPitch * sinYaw;
    q1 = sinRoll * cosPitch * cosYaw + cosRoll * sinPitch * sinYaw;
    q2 = cosRoll * sinPitch * cosYaw + sinRoll * cosPitch * sinYaw;
    q3 = cosRoll * cosPitch * sinYaw - sinRoll * sinPitch * cosYaw;
}

bool Spider2020DataSubscribe::initializeIO(ControllerIO* io) 
{
    return true;
}



extern "C"
{

  void Spider2020DataSubscribeInit(RTC::Manager* manager)
  {
    coil::Properties profile(spider2020datasubscribe_spec);
    manager->registerFactory(profile,
                             RTC::Create<Spider2020DataSubscribe>,
                             RTC::Delete<Spider2020DataSubscribe>);
  }

};


