﻿// -*- C++ -*-
/*!
 * @file  Spider2020DataSubscribeTest.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "Spider2020DataSubscribeTest.h"

// Module specification
// <rtc-template block="module_spec">
static const char* spider2020datasubscribe_spec[] =
  {
    "implementation_id", "Spider2020DataSubscribeTest",
    "type_name",         "Spider2020DataSubscribeTest",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "Fukushima Computer System",
    "category",          "Simulator",
    "activity_type",     "EVENTDRIVEN",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
Spider2020DataSubscribeTest::Spider2020DataSubscribeTest(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_InSpider2020DataIn("InSpider2020Data", m_InSpider2020Data)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
Spider2020DataSubscribeTest::~Spider2020DataSubscribeTest()
{
}



RTC::ReturnCode_t Spider2020DataSubscribeTest::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers

  // Set OutPort buffer
  addOutPort("InSpider2020Data", m_InSpider2020DataOut);

  // Set service provider to Ports

  // Set service consumers to Ports

  // Set CORBA Service Ports

  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t Spider2020DataSubscribeTest::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Spider2020DataSubscribeTest::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Spider2020DataSubscribeTest::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Spider2020DataSubscribeTest::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{

  void Spider2020DataSubscribeTestInit(RTC::Manager* manager)
  {
    coil::Properties profile(spider2020datasubscribe_spec);
    manager->registerFactory(profile,
                             RTC::Create<Spider2020DataSubscribeTest>,
                             RTC::Delete<Spider2020DataSubscribeTest>);
  }

};


